// rotuloPinyin.cc
#include "rotuloPinyin.h"
#include "global.h"

RotuloPinyin::RotuloPinyin():Rotulo(G_TextFont,0)
{
 alturaFuente=FontHeight(chf);
}

void RotuloPinyin::Draw(GC gc,char *rotulo)
{
  imprimirPinyin(gc,10,FontHeight(chf)*3/2,rotulo);
}

int RotuloPinyin::vocal(unsigned char c)
{
static unsigned char vocales[]={
                        'a',
                        'o',
                        'e',
                        'i',
                        'u',
                        ''
                        };
static unsigned char mvocales[]={
                        'A',
                        'O',
                        'E',
                        'I',
                        'U',
                        ''
                        };
int i;
   for(i=0;i<6;i++)
     if(vocales[i]==c) return 6-i;
   for(i=0;i<6;i++)
     if(mvocales[i]==c) return 6-i;

return -1;
}


int RotuloPinyin::tono(char *s, int &pos,char &caracter)
{
 int l,i;
  int v,va;
  int res;
  char b[40];

  strcpy(b,s);
  l=strlen(s)-1;
  switch(s[l])
  {
    case ' ':
    case '1': res=1;break;
    case '2': res=2;break;
    case '3': res=3;break;
    case '4': res=4;break;
    case '5': res=5;break;
    default:  res=5;break;
  }
  va=pos=-1;
  for(i=0;i<l;i++)
  {
    v=vocal(s[i]);
    if(v>va)
    {
      va=v;
      pos=i;
    }
  }
  if(pos>=0)
  {
    caracter=b[pos];
    b[pos]=0;
    pos=anchura(b);
  }
  return res;

}

void RotuloPinyin::escribirTono(int t, int x,int y,unsigned char c)
{
  int dx,dy;
  unsigned char buffer[2];

  buffer[0]=c;
  buffer[1]=0;

    dx=anchura((char *)buffer)*2/3;
    dy=alturaFuente/4;
    y -=alturaFuente *7/8;
    if(dx<8)
    {
      dx=8;
      x -=2;
    }
    else
      x +=anchura((char *)buffer)*1/3;

   SetLineWidth(alturaFuente/16+1);
   switch(t)
   {
     case 1: DrawLine(x,y-dy/2,x+dx,y-dy/2);
             DrawLine(x,y-dy/2+1,x+dx,y-dy/2+1);
	     break;
     case 2: DrawLine(x,y,x+dx,y-dy);
	     DrawLine(x,y,x+dx,y+1-dy);
	     break;
     case 3: DrawLine(x,y-dy/2,x+dx/2,y+1);
             DrawLine(x+dx/2,y+1,x+dx,y-dy);
             DrawLine(x,y-dy/2,x+dx/2,y);
             DrawLine(x+dx/2,y,x+dx,y-dy);
             break;
     case 4: DrawLine(x,y-dy,x+dx,y+1);
	     DrawLine(x,y-dy,x+dx,y);
             break;
     case 5: /*circle(x+dx/2,y-dy/3,bytes-1*/;break;
   }
}


void RotuloPinyin::imprimirPinyin(GC gc,int x, int y, char *s)
{
  int t;
  int pos,i=0,j=0;
  char buffer[100];
  char caracter;
  Display *display=XtDisplay(w);
  Window ventana=(Window)XtWindow(w);

  while(s[j])
  {
    buffer[i]=s[j];
    if (buffer[i]==' ' || (buffer[i]>='1' && buffer[i]<='5') || s[j+1]==0)
    {
      buffer[i+1]=0;
      t=tono(buffer,pos,caracter);
      if(buffer[i]) buffer[i]=0;
   XDrawImageString(display, ventana, gc, x, y, buffer,strlen(buffer));
      escribirTono(t,x+pos,y,caracter);
      if(buffer[i]) buffer[i]=0;
      x=x+anchura(buffer);
      i=0;
    }
    else
     i++;
    j++;
  }

}
